@if "%debug%" == "" @echo off
rem The "shortcuts" on the nu2menu do not support setting the working folder (Start in:).
rem Change current drive and path to location of the files, so we don't have to specify a full path for each file.
%~d0
cd %~dp0
if "%target_root%"=="" goto SetTargetRoot
goto query

:SetTargetRoot
echo running SetTargetRoot.exe
SetTargetRoot.exe

rem SetTargetRoot.exe sets the environment variable %TARGET_ROOT%, but it seems to set it at
rem the global environment level. The environment of batch files (like this one) is inherited 
rem from the global environment at the time that the batch is started. It does not receive
rem updates from the global environment (like setting new environment variables). Therefore
rem we need to set %TARGET_ROOT% inside this batch environment based on what SetTargetRoot.exe
rem has just set it to in the global environment.
for /F "usebackq skip=2 tokens=3" %%a in (`reg.exe query "HKLM\SYSTEM\ControlSet001\Control\Session Manager\Environment" /v TARGET_ROOT`) do set TARGET_ROOT=%%a
goto query

:query
rem Check if the current %TARGET_ROOT% is the one we want
echo TARGET_ROOT is the directory containing the Windows installation that the
echo drivers will be injected into, e.g. C:\Windows
echo.
echo The current TARGET_ROOT setting is
echo %TARGET_ROOT%
goto check
rem User should not get to this next step unless they cancel (ctrl+c) the choice.com above.
rem Just in case they do, handle it with an exit (abort the script).
if not "%debug%" == "" pause
exit

:override
rem Override %target_root%
echo.
echo Enter the path to TARGET_ROOT
echo For example: C:\Windows
set /P TARGET_ROOT=
goto check

:check
if "%target_root%" == "" goto errorNotSet
if not exist %target_root%\system32\config\SYSTEM goto errorNotExist
goto run

:errorNotSet
echo.
echo ERROR: Target Root not set. Exiting...
echo.
pause
exit

:errorNotExist
echo.
echo ERROR: This does not appear to be a valid Windows installation.
echo        Cannot find the System Registry (i.e. HKLM\SYSTEM) within TARGET_ROOT 
echo        (%target_root%)
echo        Exiting...
echo.
pause
exit

:run
rem End this batch and run the code in the parent batch
goto end

:end
rem echo EOF
